SimpleJavaFileObject (Java SE 26 & JDK 26)
Description: declaration: module: java.compiler, package: javax.tools, class: SimpleJavaFileObject
Keywords: javax.tools.SimpleJavaFileObject class

# Class SimpleJavaFileObject

java.lang.Object
javax.tools.SimpleJavaFileObject

All Implemented Interfaces:
  `FileObject, JavaFileObject`

public class SimpleJavaFileObject extends Object implements JavaFileObject
Provides simple implementations for most methods in JavaFileObject. This class is designed to be subclassed and used as a basis for JavaFileObject implementations. Subclasses can override the implementation and specification of any method of this class as long as the general contract of JavaFileObject is obeyed.

Since:
  1.6

- ## Nested Class Summary

  ### Nested classes/interfaces declared in interface JavaFileObject

  `JavaFileObject.Kind`
  Modifier and Type
  Interface
  Description
  `static enum`
  `JavaFileObject.Kind`
  Kinds of JavaFileObjects.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final JavaFileObject.Kind`
  `kind`
  The kind of this file object.
  `protected final URI`
  `uri`
  A URI for this file object.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `SimpleJavaFileObject(URI uri, JavaFileObject.Kind kind)`
  Construct a SimpleJavaFileObject of the given kind and with the given URI.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `delete()`
  Deletes this file object.
  `static JavaFileObject`
  `forSource(URI uri, String content)`
  Creates a `JavaFileObject` which represents the given source content.
  `Modifier`
  `getAccessLevel()`
  Provides a hint about the access level of the class represented by this file object.
  `CharSequence`
  `getCharContent(boolean ignoreEncodingErrors)`
  Returns the character content of this file object, if available.
  `JavaFileObject.Kind`
  `getKind()`
  Returns the kind of this file object.
  `long`
  `getLastModified()`
  Returns the time this file object was last modified.
  `String`
  `getName()`
  Returns a user-friendly name for this file object.
  `NestingKind`
  `getNestingKind()`
  Provides a hint about the nesting level of the class represented by this file object.
  `boolean`
  `isNameCompatible(String simpleName, JavaFileObject.Kind kind)`
  Checks if this file object is compatible with the specified simple name and kind.
  `InputStream`
  `openInputStream()`
  Returns an InputStream for this file object.
  `OutputStream`
  `openOutputStream()`
  Returns an OutputStream for this file object.
  `Reader`
  `openReader(boolean ignoreEncodingErrors)`
  Returns a reader for this object.
  `Writer`
  `openWriter()`
  Returns a Writer for this file object.
  `URI`
  `toUri()`
  Returns a URI identifying this file object.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### uri

    protected final URI uri
    A URI for this file object.

  - ### kind

    protected final JavaFileObject.Kind kind
    The kind of this file object.

- ## Constructor Details

  - ### SimpleJavaFileObject

    protected SimpleJavaFileObject(URI uri, JavaFileObject.Kind kind)
    Construct a SimpleJavaFileObject of the given kind and with the given URI.
    Parameters:
      `uri` - the URI for this file object
      `kind` - the kind of this file object

- ## Method Details

  - ### toUri

    public URI toUri()
    Description copied from interface: `FileObject`
    Returns a URI identifying this file object.
    Specified by:
      `toUri` in interface `FileObject`
    Returns:
      a URI

  - ### getName

    public String getName()
    Description copied from interface: `FileObject`
    Returns a user-friendly name for this file object. The exact value returned is not specified but implementations should take care to preserve names as given by the user. For example, if the user writes the filename `"BobsApp\Test.java"` on the command line, this method should return `"BobsApp\Test.java"` whereas the toUri method might return `file:///C:/Documents%20and%20Settings/UncleBob/BobsApp/Test.java`.
    Specified by:
      `getName` in interface `FileObject`
    Returns:
      a user-friendly name

  - ### openInputStream

    public InputStream openInputStream() throws IOException
    Returns an InputStream for this file object.
    Specified by:
      `openInputStream` in interface `FileObject`
    Implementation Requirements:
      This implementation always throws UnsupportedOperationException.
    Returns:
      an InputStream
    Throws:
      `IOException` - if an I/O error occurred

  - ### openOutputStream

    public OutputStream openOutputStream() throws IOException
    Returns an OutputStream for this file object.
    Specified by:
      `openOutputStream` in interface `FileObject`
    Implementation Requirements:
      This implementation always throws UnsupportedOperationException.
    Returns:
      an OutputStream
    Throws:
      `IOException` - if an I/O error occurred

  - ### openReader

    public Reader openReader(boolean ignoreEncodingErrors) throws IOException
    Returns a reader for this object. The returned reader will replace bytes that cannot be decoded with the default translation character. In addition, the reader may report a diagnostic unless `ignoreEncodingErrors` is true.
    Specified by:
      `openReader` in interface `FileObject`
    Implementation Requirements:
      This implementation wraps the result of `getCharContent(boolean)` in a `Reader`.
    Parameters:
      `ignoreEncodingErrors` - ignore encoding errors if true
    Returns:
      a Reader wrapping the result of getCharContent
    Throws:
      `IllegalStateException` - if this file object was opened for writing and does not support reading
      `UnsupportedOperationException` - if this kind of file object does not support character access
      `IOException` - if an I/O error occurred

  - ### getCharContent

    public CharSequence getCharContent(boolean ignoreEncodingErrors) throws IOException
    Returns the character content of this file object, if available. Any byte that cannot be decoded will be replaced by the default translation character. In addition, a diagnostic may be reported unless `ignoreEncodingErrors` is true.
    Specified by:
      `getCharContent` in interface `FileObject`
    Implementation Requirements:
      This implementation always throws UnsupportedOperationException.
    Parameters:
      `ignoreEncodingErrors` - ignore encoding errors if true
    Returns:
      a CharSequence if available; `null` otherwise
    Throws:
      `IOException` - if an I/O error occurred

  - ### openWriter

    public Writer openWriter() throws IOException
    Returns a Writer for this file object.
    Specified by:
      `openWriter` in interface `FileObject`
    Implementation Requirements:
      This implementation wraps the result of `openOutputStream()` in a `Writer`.
    Returns:
      a Writer wrapping the result of openOutputStream
    Throws:
      `IllegalStateException` - if this file object was opened for reading and does not support writing
      `UnsupportedOperationException` - if this kind of file object does not support character access
      `IOException` - if an I/O error occurred

  - ### getLastModified

    public long getLastModified()
    Returns the time this file object was last modified. The time is measured in milliseconds since the epoch (00:00:00 GMT, January 1, 1970).
    Specified by:
      `getLastModified` in interface `FileObject`
    Implementation Requirements:
      This implementation returns `0L`.
    Returns:
      `0L`

  - ### delete

    public boolean delete()
    Deletes this file object. In case of errors, returns false.
    Specified by:
      `delete` in interface `FileObject`
    Implementation Requirements:
      This implementation does nothing.
    Returns:
      `false`

  - ### getKind

    public JavaFileObject.Kind getKind()
    Description copied from interface: `JavaFileObject`
    Returns the kind of this file object.
    Specified by:
      `getKind` in interface `JavaFileObject`
    Returns:
      `this.kind`

  - ### isNameCompatible

    public boolean isNameCompatible(String simpleName, JavaFileObject.Kind kind)
    Checks if this file object is compatible with the specified simple name and kind. A simple name is a single identifier (not qualified) as defined in The Java Language Specification, section 6.2.
    Specified by:
      `isNameCompatible` in interface `JavaFileObject`
    Implementation Requirements:
      This implementation compares the path of its URI to the given simple name. This method returns true if the given kind is equal to the kind of this object, and if the path is equal to `simpleName + kind.extension` or if it ends with `"/" + simpleName + kind.extension`.

      This method calls `getKind()` and `toUri()` and does not access the fields `uri` and `kind` directly.

    Parameters:
      `simpleName` - a simple name of a class
      `kind` - a kind
    Returns:
      `true` if this file object is compatible; `false` otherwise

  - ### getNestingKind

    public NestingKind getNestingKind()
    Provides a hint about the nesting level of the class represented by this file object. This method may return `NestingKind.MEMBER` to mean `NestingKind.LOCAL` or `NestingKind.ANONYMOUS`. If the nesting level is not known or this file object does not represent a class file this method returns `null`.
    Specified by:
      `getNestingKind` in interface `JavaFileObject`
    Implementation Requirements:
      This implementation returns `null`.
    Returns:
      the nesting kind, or `null` if the nesting kind is not known

  - ### getAccessLevel

    public Modifier getAccessLevel()
    Provides a hint about the access level of the class represented by this file object. If the access level is not known or this file object does not represent a class file this method returns `null`.
    Specified by:
      `getAccessLevel` in interface `JavaFileObject`
    Implementation Requirements:
      This implementation returns `null`.
    Returns:
      the access level

  - ### forSource

    public static JavaFileObject forSource(URI uri, String content)
    Creates a `JavaFileObject` which represents the given source content.

    The provided `uri` will be returned from `toUri()`. The provided `content` will be returned from `getCharContent(boolean)`. The `getKind()` method will return `JavaFileObject.Kind.SOURCE`.

    All other methods will behave as described in the documentation in this class, as if the constructor is called with `uri` and `Kind.SOURCE`.

    This method can be, for example, used to compile an in-memory String to a set of classfile in a target directory:

             var code = """
                        public class CompiledCode {}
                        """;
             var compiler = ToolProvider.getSystemJavaCompiler();
             var targetDirectory = "...";
             var task = compiler.getTask(null,
                                         null,
                                         null,
                                         List.of("-d", targetDirectory),
                                         null,
                                         List.of(SimpleJavaFileObject.forSource(URI.create("CompiledCode.java"), code)));
             if (!task.call()) {
                 throw new IllegalStateException("Compilation failed!");
             }

    Parameters:
      `uri` - that should be used for the resulting `JavaFileObject`
      `content` - the content of the `JavaFileObject`
    Returns:
      a `JavaFileObject` representing the given source content.
    Since:
      23